# UOC TECH DAY - MADRID
# Carlos Monzo (cmonzo@uoc.edu)
# EIMT - UOC

#install.packages("twitteR") # Only first time
#install.packages("ggmap")   # Only first time
#install.packages("rjson")   # Only first time
#install.packages("lattice")   # Only first time
library(twitteR)
library(ggmap)
library(rjson)
library(lattice) 
source("paste0.R")

# setup_twitter_oauth("APIkey","APIsecret","Accesstoken","Accesssecret")

# keyword <- "Madrid"

# tweets <- searchTwitter(keyword, n=20000, geocode='40.41,-3.70,100km')
# dftotal<-twListToDF(tweets) # Conversion to Data Frame

load("madrid5000.RData")
dftotal[1:2,]
dim(dftotal)
print(dftotal$created[length(dftotal$created)])
print(dftotal$created[1])

## Plotting

hist(as.POSIXlt(dftotal$created+7200),breaks="hours",freq=T,main="Recuento tweets en Madrid",xlab="Periodo: 18 al 27 de Mayo [por hora]",ylab="Frecuencia",format = "%H")

# map12 <- get_map(location = c(lon=-3.7,lat=40.42), zoom = 12)

ggmap(map12)

lat_ex <- as.numeric(dftotal$latitude)
lon_ex <- as.numeric(dftotal$longitude)

mapPoints <- ggmap(map12) + 
  geom_point(aes(x = lon_ex , y = lat_ex), size = 3 , data = dftotal, alpha = .3, colour="red")
mapPoints

## Zoom in

# map14 <- get_map(location = c(lon=-3.7,lat=40.42), zoom = 14)

ggmap(map14)

lat_ex <- as.numeric(dftotal$latitude)
lon_ex <- as.numeric(dftotal$longitude)

mapPoints <- ggmap(map14) + 
  geom_point(aes(x = lon_ex , y = lat_ex), size = 3 , data = dftotal, alpha = .3, colour="red")
mapPoints

## Reverse geolocalization

# url <- 'https://maps.googleapis.com/maps/api/geocode/json?latlng=40.42,-3.7'
# documento_ejemplo <- fromJSON(file=url, method='C')

geodataframe[10:15,c(1,2,3,4,5,6)]

sort(table(geodataframe$city))

# Limitinig to Madrid CP's

sort(table(geodataframe$cp[grepl("^280",geodataframe$cp)]),decreasing=T)[1:20]

counts <- sort(table(geodataframe$cp[grepl("^280",geodataframe$cp)]),decreasing=T)[1:20]
par(las=2) # make label text perpendicular to axis
par(mar=c(5,8,4,2)) # increase y-axis margin.
barplot(counts, main="Tweets por CP in Madrid", horiz=TRUE,
        names.arg=names(sort(table(geodataframe$cp[grepl("^280",geodataframe$cp)]),decreasing=T)[1:20]),
        cex.names=0.9) 

colors <- as.numeric(geodataframe$cp)

# Areas
mapPoints <- ggmap(map12) + 
geom_point(aes(x = lon_ex , y = lat_ex), size = 3 , data = dftotal, alpha = .4, colour=colors)
mapPoints

mapPoints <- ggmap(map14) + 
  geom_point(aes(x = lon_ex , y = lat_ex), size = 3 , data = dftotal, alpha = .4, colour=colors)
mapPoints

# Table of 20 most busy streets
sort(table(geodataframe$street),decreasing=TRUE)[1:20]

# Time relation with 10 most busy streets
temp <- data.frame(dftotal$created,as.character(geodataframe$street))
pattern <- paste(names(sort(table(geodataframe$street),decreasing=TRUE)[1:10]),collapse="|")
temp <- temp[grepl(pattern,temp[,2]),]
names(temp)<-c("created","street")
histogram( ~ as.POSIXlt(strptime(format(temp[,1], format="%H:%M:%S"),format="%H:%M:%S")+7200)$hour  | temp[,2],
           data = temp, xlab="Hora del dia",ylab="Porcentaje",main="Distribucion horaria de tweets en las zonas de mayor actividad de Madrid", breaks=24 )
